Loading...
Searching...
No Matches
Sip_allow

## Data Structures

struct | sip_allow_s
| Structure for Allow header field. More...

## Macros

#define | sip_allow(sip)
| Access a SIP Allow header structure sip_allow_t from sip_t.
#define | SIP_ALLOW_INIT()
| Initializer for structure sip_allow_t.
#define | SIPTAG_ALLOW(x)
| Tag list item for pointer to a Allow header structure sip_allow_t.
#define | SIPTAG_ALLOW_REF(x)
| Tag list item for reference to a Allow header pointer.
#define | SIPTAG_ALLOW_STR(s)
| Tag list item for string with Allow header value.
#define | SIPTAG_ALLOW_STR_REF(x)
| Tag list item for reference to a Allow header string.

## Typedefs

typedef struct sip_allow_s | sip_allow_t
| @

## Functions

issize_t | sip_allow_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Allow header.
issize_t | sip_allow_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Allow header.
sip_allow_t * | sip_allow_init (sip_allow_t x[1])
| Initialize a structure sip_allow_t.
int | sip_is_allow (sip_header_t const *header)
| Test if header object is instance of sip_allow_t.
sip_allow_t * | sip_allow_dup (su_home_t *home, sip_allow_t const *hdr))
| Duplicate a list of Allow header header structures sip_allow_t.
sip_allow_t * | sip_allow_copy (su_home_t *home, sip_allow_t const *hdr))
| Copy a list of Allow header header structures sip_allow_t.
sip_allow_t * | sip_allow_make (su_home_t *home, char const *s))
| Make a Allow header structure sip_allow_t.
sip_allow_t * | sip_allow_format (su_home_t *home, char const *fmt,...)))
| Make a Allow header from formatting result.

## Variables

msg_hclass_t | sip_allow_class []
| Header class for Allow header.
tag_typedef_t | siptag_allow
| Tag for Allow header object.
tag_typedef_t | siptag_allow_str
| Tag for string with Allow header value.

## Detailed Description

## Macro Definition Documentation

## SIP_ALLOW_INIT

#define SIP_ALLOW_INIT | ( |  | ) |

Initializer for structure sip_allow_t.

A static sip_allow_t structure for Allow header must be initialized with the SIP_ALLOW_INIT() macro. For instance,

sip_allow_t sip_allow = SIP_ALLOW_INIT;
sip_allow_t
struct sip_allow_s sip_allow_t
@
Definition sip.h:142
sip_allow
#define sip_allow(sip)
Access a SIP Allow header structure sip_allow_t from sip_t.
Definition sip_protos.h:7747
SIP_ALLOW_INIT
#define SIP_ALLOW_INIT()
Initializer for structure sip_allow_t.
Definition sip_protos.h:7764

## SIPTAG_ALLOW

#define SIPTAG_ALLOW | ( |  | x | ) |

Tag list item for pointer to a Allow header structure sip_allow_t.

The SIPTAG_ALLOW() macro is used to include a tag item with a pointer to a sip_allow_t structure in a tag list.

Parameters

  x | pointer to a sip_allow_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_ALLOW_REF().

## SIPTAG_ALLOW_STR

#define SIPTAG_ALLOW_STR | ( |  | s | ) |

Tag list item for string with Allow header value.

The SIPTAG_ALLOW_STR() macro is used to include a tag item with a string containing value of a sip_allow_t header in a tag list.

Parameters

  s | pointer to a string containing Allow header value, or NULL.

The string in SIPTAG_ALLOW_STR() can be converted to a sip_allow_t header structure by giving the string s has second argument to function sip_allow_make().

The corresponding tag taking reference parameter is SIPTAG_ALLOW_STR_REF().

## Typedef Documentation

## sip_allow_t

typedef struct sip_allow_s sip_allow_t

@

The Allow header lists the set of methods supported by the user agent generating the message. Its syntax is defined in RFC 3261 as follows:

Allow = "Allow" HCOLON [Method *(COMMA Method)]

The parsed Allow header is stored in sip_allow_t structure.

Note that SIP methods are case-sensitive: "INVITE" method is different from "Invite".

See also
  msg_header_find_item(), msg_header_replace_item(), msg_header_remove_item()

The structure sip_allow_t contains representation of an Allow header.

The sip_allow_t is defined as follows:

typedef struct msg_allow_s
{
msg_common_t k_common[1]; // Common fragment info
msg_list_t *k_next; // Link to next header
msg_param_t *k_items; // List of items
uint32_t k_bitmap; // Bitmap of allowed methods
} sip_allow_t;
msg_list_t
struct msg_list_s msg_list_t
msg_common_t
struct msg_common_s msg_common_t
uint32_t
SU_U32_T uint32_t

Note
  The field k_bitmap was added in 1.12.5.

## Function Documentation

## sip_allow_copy()

sip_allow_t * sip_allow_copy | ( | su_home_t * | home,
|  | sip_allow_t const * | hdr )

inline

Copy a list of Allow header header structures sip_allow_t.

The function sip_allow_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  allow = sip_allow_copy(home, sip->sip_allow);
  sip_allow_copy
  sip_allow_t * sip_allow_copy(su_home_t *home, sip_allow_t const *hdr))
  Copy a list of Allow header header structures sip_allow_t.
  Definition sip_protos.h:7894

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_allow_dup()

sip_allow_t * sip_allow_dup | ( | su_home_t * | home,
|  | sip_allow_t const * | hdr )

inline

Duplicate a list of Allow header header structures sip_allow_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  allow = sip_allow_dup(home, sip->sip_allow);
  sip_allow_dup
  sip_allow_t * sip_allow_dup(su_home_t *home, sip_allow_t const *hdr))
  Duplicate a list of Allow header header structures sip_allow_t.
  Definition sip_protos.h:7851

Returns
  A pointer to the newly duplicated sip_allow_t header structure, or NULL upon an error.

## sip_allow_format()

sip_allow_t * sip_allow_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Allow header from formatting result.

Make a new sip_allow_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_allow_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_allow_init()

sip_allow_t * sip_allow_init | ( | sip_allow_t | x[1] | ) |

inline

Initialize a structure sip_allow_t.

An sip_allow_t structure for Allow header can be initialized with the sip_allow_init() function/macro. For instance,

sip_allow_t sip_allow;
sip_allow_init(&sip_allow);
sip_allow_init
sip_allow_t * sip_allow_init(sip_allow_t x[1])
Initialize a structure sip_allow_t.
Definition sip_protos.h:7782

## sip_allow_make()

sip_allow_t * sip_allow_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Allow header structure sip_allow_t.

The function sip_allow_make() makes a new sip_allow_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_allow_t header structure, or NULL upon an error.

## sip_is_allow()

int sip_is_allow | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_allow_t.

Check if the header class is an instance of Allow header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header allow
  0 | (false) otherwise

## Variable Documentation

## sip_allow_class

msg_hclass_t sip_allow_class[]

extern

Header class for Allow header.

The header class sip_allow_class defines how a SIP Allow header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_allow_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.